dwt2Hwt_oddorth(dom_wt) = {
  my(res);
  res = vector(2+#dom_wt);
  if(Mod(#dom_wt,2)==0, res[1] = 1, res[2] = 1);
  for(u=1, #dom_wt,
    res[2+u] = 2*(dom_wt[#dom_wt+1-u]+u);
  );
  return(res);
};

enum_wts_oddorth(motw) = {
  my(dom_wt,i,res,cur);
  res = [];
  for(rk=1, motw/2,
    dom_wt = vector(rk);
    dom_wt[1] = motw/2-rk;
    cur = [];
    while(2*(dom_wt[1]+rk) == motw,
      cur = concat(cur, [dwt2Hwt_oddorth(dom_wt)]);
      i = rk;
      dom_wt[i] += 1;
      while(i>1 && dom_wt[i]>dom_wt[i-1],
        dom_wt[i] = 0;
        i -= 1;
        dom_wt[i] += 1;
      );
    );
    res = concat(res, cur);
  );
  return(res);
};

\\ input: dominant weight for SO_odd
dwt2Hwt_sympl(dom_wt) = {
  my(res);
  res = vector(2+#dom_wt);
  for(u=1, #dom_wt,
    res[2+u] = 2*(dom_wt[#dom_wt+1-u]+u)-1;
  );
  return(res);
};

enum_wts_sympl(motw) = {
  my(dom_wt,i,res,cur);
  res = [];
  for(rk=1, (motw+1)/2,
    dom_wt = vector(rk);
    dom_wt[1] = (motw+1)/2-rk;
    cur = [];
    while(2*(dom_wt[1]+rk) == 1+motw,
      cur = concat(cur, [dwt2Hwt_sympl(dom_wt)]);
      i = rk;
      dom_wt[i] += 1;
      while(i>1 && dom_wt[i]>dom_wt[i-1],
        dom_wt[i] = 0;
        i -= 1;
        dom_wt[i] += 1;
      );
    );
    res = concat(res, cur);
  );
  return(res);
};

dwt2Hwt_evenorth(dom_wt) = {
  my(res);
  if(dom_wt[#dom_wt]==0,
    res = vector(1+#dom_wt);
    res[1] = 1;
    res[2] = 1;
    for(u=2, #dom_wt,
      res[1+u] = 2*(dom_wt[#dom_wt+1-u]+u-1);
    );
  ,
    res = vector(2+#dom_wt);
    res[3] = 2*dom_wt[#dom_wt];
    for(u=2, #dom_wt,
      res[2+u] = 2*(dom_wt[#dom_wt+1-u]+u-1);
    );
  );
  return(res);
};

enum_wts_evenorth(motw) = {
  my(dom_wt,i,res,cur);
  res = [];
  for(rk=2, 1+motw/2,
    if(Mod(rk,2)==0,
      dom_wt = vector(rk);
      dom_wt[1] = motw/2-rk+1;
      cur = [];
      while(2*(dom_wt[1]+rk-1) == motw,
        cur = concat(cur, [dwt2Hwt_evenorth(dom_wt)]);
        i = rk;
        dom_wt[i] += 1;
        while(i>1 && dom_wt[i]>dom_wt[i-1],
          dom_wt[i] = 0;
          i -= 1;
          dom_wt[i] += 1;
        );
      );
      res = concat(res, cur);
    );
  );
  return(res);
};

enum_wts_orth(motw) = concat(enum_wts_oddorth(motw), enum_wts_evenorth(motw));

