max_rk_SO_odd = 8
max_rk_Sp = 8
max_rk_SO_even = 8
max_rk = max(max_rk_SO_odd, max_rk_Sp, max_rk_SO_even)

# weight bounds determining for what dominant weights we will compute everything
# there will be other weights, coming from condition (P1'):
# see combi_pre_endo.sage
# the first term must be at least equal to the maximum of the three maxw_* lists
# below
wt_bounds = (15, 1, 2)

# for each group, we assume that no tempered non-endo (including twisted for
# SO_even) contributions for all weights corresponding to motivic weight <=2*k
# below is a list of k's
maxw_SO_odd = [3, 5, 5, 5, 5, 5, 5, 12]
maxw_Sp = [5, 5, 5, 5, 5, 5, 5, 11]
maxw_SO_even = [5, 5, 5, 11]

masses_SO_odd = []
masses_SO_even = []
masses_Sp = []
# once masses are computed and saved, one can simply load them instead of
# solving the linear system again
#masses_SO_odd = [load_from_txt("data/masses/masses_SO"+str(2*n+1)+".txt")
#                 for n in range(1, max_rk_SO_odd+1)]
#masses_SO_even = [load_from_txt("data/masses/masses_SO"+str(2*n)+".txt")
#                  for n in range(1, max_rk_SO_even+1) if (n%2)==0]
#masses_Sp = [load_from_txt("data/masses/masses_Sp"+str(2*n)+".txt")
#             for n in range(1, max_rk_Sp+1)]

db = {}
append_db(db, "../contradict_vect/db_reg_selfdual_mixed")
# check that up to Sp_12, SO_12 and SO_15 we only use Corollary 2.3
# i.e. that the mask is always zero
for wt, val in db.items():
    if dimw(wt)<15 and val[2]!=0:
        print(wt)
        raise ValueError

other_wt = []
other_dw_SO_odd = [[] for i in range(max_rk_SO_odd)]
other_maxw_SO_odd = [3, 12, 14, 14, 14, 14, 18, 32]
for n in range(len(masses_SO_odd)+1, max_rk_SO_odd+1):
    for i in range(maxw_SO_odd[n-1]+1, other_maxw_SO_odd[n-1]+1):
        other_dw_SO_odd[n-1].extend(verify_reg_selfdual(db, 2*i-1, 2*n))
        other_wt.extend(wt for wt in db
                           if dimw(wt)==2*n and len(wt)>2 and wt[-1]==2*i-1)
other_dw_Sp = [[] for i in range(max_rk_Sp)]
other_maxw_Sp = [7, 14, 14, 14, 14, 14, 18, 18]
for n in range(len(masses_Sp)+1, max_rk_Sp+1):
    for i in range(maxw_Sp[n-1]+1, other_maxw_Sp[n-1]+1):
        other_dw_Sp[n-1].extend(verify_reg_selfdual(db, 2*i, 2*n+1))
        other_wt.extend(wt for wt in db
                           if dimw(wt)==2*n+1 and len(wt)>2 and wt[-1]==2*i)
other_dw_SO_even = [[] for i in range(ZZ(max_rk_SO_even/2))]
other_maxw_SO_even = [13, 14, 14, 14]
for n in range(len(masses_SO_even)+1, max_rk_SO_even/2+1):
    for i in range(maxw_SO_even[n-1]+1, other_maxw_SO_even[n-1]+1):
        other_dw_SO_even[n-1].extend(verify_reg_selfdual(db, 2*i, 4*n))
        other_wt.extend(wt for wt in db
                           if dimw(wt)==4*n and len(wt)>2 and wt[-1]==2*i)

# ugly hack: elliptic terms for PGL2=SO3 occur in parabolic terms for all groups
# we do not attempt to determine which weights occur precisely and just compute
# a lot of them
other_wt.extend((0, 0, 2*i+1) for i in range(200))
ctx = pre_endo_ctx(other_wt, 2*wt_bounds[0]+1)
# to avoid IndexError's if masses are simply loaded, we fill ctx
for n in range(len(ctx.SO_odd)+1, max_rk_SO_odd+1):
    ctx.SO_odd.append(set())
    ctx.SO_odd_bymask.append([[] for j in range(1<<n)])
for n in range(len(ctx.Sp)+1, max_rk_Sp+1):
    ctx.Sp.append(set())
    ctx.Sp_bymask.append([[] for j in range(1<<n)])
for n in range(len(ctx.SO_even)+1, max_rk_SO_even/2+1):
    ctx.SO_even.append(set())
    ctx.SO_even_bymask.append([[] for j in range(1<<(2*n))])

elliptic_traces_SO_odd = [{() : 1}]
elliptic_traces_SO_even = [{() : 1}]
elliptic_traces_Sp = [{() : 1}]
EPchar_list_SO_odd = []
EPchar_list_SO_even = []
EPchar_list_Sp = []
new_sympl_para_list = []
new_orth_odd_para_list = [{(): 1}]
new_orth_even_para_list = [] # even dimension => dim = 4k

# for Sp and SO_even, we will compute masses indexed
def reconstruct_cc_mass_dict_CD(cc_list, mass_vect):
    mass_dict = {}
    for i, cc in enumerate(cc_list):
        if mass_vect[i]==0:
            continue
        mass_dict[cc] = mass_vect[i]
        opp_cc = opposite_cc(cc)
        if opp_cc!=cc:
            mass_dict[opp_cc] = mass_vect[i]
    return mass_dict

def compute_all():
    for n in range(1, max_rk+1):
        # SO_{2n+1}
        if n<=max_rk_SO_odd:
            print("SO_"+str(2*n+1)+":")
            EP_minus_elliptic = EPchar_SO_odd(n, elliptic_traces_SO_odd,
                    wt_bounds, ctx.SO_odd[n-1], minus_elliptic=True)
            print(" Computed EP char minus Tell")
            endo_contrib = parallel_all_endo_contrib_SO_odd(n, wt_bounds,
                    ctx.SO_odd_bymask[n-1], new_sympl_para_list,
                    new_orth_odd_para_list, new_orth_even_para_list)
            print(" Computed endoscopic contributions to EP char")
            if len(masses_SO_odd)<n:
                dw_list = [dw for dw in it_dw_SO_odd(n, maxw_SO_odd[n-1],1,2)]\
                         +other_dw_SO_odd[n-1]
                # the assumption is that for these weights,
                # EP_minus_elliptic + ell_tr = q(G)*endo_contrib
                ell_tr_vect = vector(QQ,
                        [(-1)^(n*(n+1)/2)*endo_contrib[dw]-EP_minus_elliptic[dw]
                         for dw in dw_list])
                cc_list, traces_mat = mat_tr_alg_rep('B', n, dw_list,
                                                     relevant_cc_Qbar_SO(2*n+1))
                print(" "+str(len(dw_list)) +" equations, "+str(len(cc_list))
                      +" unknown")
                if traces_mat.rank()<len(cc_list):
                    raise ValueError("Not enough weights for SO_"+str(2*n+1))
                mass_vect = traces_mat.solve_left(ell_tr_vect)
                if mass_vect*traces_mat!=ell_tr_vect:
                    raise ValueError("Solving the linear system failed")
                else:
                    print(" Solved the linear system and computed masses")
                cc_mass_dict = {cc: mass_vect[i] for i, cc in enumerate(cc_list)
                                                  if mass_vect[i]!=0}
                van_masses = [cc for i, cc in enumerate(cc_list)
                                 if mass_vect[i]==0]
                if len(van_masses)>0:
                    print(" Vanishing masses: "+str(van_masses))
                masses_SO_odd.append(cc_mass_dict)
            if len(elliptic_traces_SO_odd)<n+1:
                ell_tr_dict = contrib_ell_SO_odd(n, wt_bounds, ctx.SO_odd[n-1],
                                                 masses_SO_odd[n-1])
                print(" Computed Tell")
                elliptic_traces_SO_odd.append(ell_tr_dict)
            else:
                ell_tr_dict = elliptic_traces_SO_odd[n]
            if len(EPchar_list_SO_odd)<n:
                EPchar_list_SO_odd.append(
                        {dw: EP_minus_elliptic[dw]+ell_tr_dict[dw]
                         for dw in chain_gen(it_dw_SO_odd(n, *wt_bounds),
                             ctx.SO_odd[n-1])})
            card_Lpacket = binomial(n, int(n/2))
            num_new_para = \
                  {dw: ((-1)^(n*(n+1)/2)*(EP_minus_elliptic[dw]+ell_tr_dict[dw])
                        -endo_contrib[dw]) / card_Lpacket
                        for dw in chain_gen(it_dw_SO_odd(n, *wt_bounds),
                                            ctx.SO_odd[n-1]) }
            if len(new_sympl_para_list)<n:
                new_sympl_para_list.append(num_new_para)
        # SO_{2n} if n is even
        if n<=max_rk_SO_even and Mod(n,2)==Mod(0,2):
            print("SO_"+str(2*n)+":")
            EP_minus_elliptic = EPchar_SO_even(n, elliptic_traces_SO_even,
                    elliptic_traces_SO_odd[1], wt_bounds, ctx.SO_even[n/2-1],
                    minus_elliptic=True)
            print(" Computed EP char minus Tell")
            endo_contrib = parallel_all_endo_contrib_SO_even(n, wt_bounds,
                    ctx.SO_even_bymask[n/2-1], new_sympl_para_list,
                    new_orth_odd_para_list, new_orth_even_para_list)
            print(" Computed endoscopic contributions to EP char")
            if len(masses_SO_even)<n/2:
                dw_list = \
                       [dw for dw in it_dw_SO_even(n, maxw_SO_even[n/2-1], 1, 2)
                           if Mod(sum(dw),2)==0] \
                     + [dw for dw in other_dw_SO_even[n/2-1]
                           if Mod(sum(dw),2)==0]
                ell_tr_vect = vector(QQ, [endo_contrib[dw]-EP_minus_elliptic[dw]
                                          for dw in dw_list])
                cc_list, traces_mat = \
                       mat_tr_alg_rep('D', n, dw_list, relevant_cc_Qbar_SO(2*n))
                print(" "+str(len(dw_list))+" equations, "+str(len(cc_list))
                      +" unknown")
                if traces_mat.rank()<len(cc_list):
                    raise ValueError("Not enough weights for SO_"+str(2*n))
                #print(str(cc_list)+"\n"+str(traces_mat)+ "\n" + str(ell_tr_vect))
                mass_vect = traces_mat.solve_left(ell_tr_vect)
                if mass_vect*traces_mat!=ell_tr_vect:
                    raise ValueError("Solving the linear system failed for SO_"
                                     +str(2*n))
                else:
                    print(" Solved the linear system and computed masses")
                cc_mass_dict = reconstruct_cc_mass_dict_CD(cc_list, mass_vect)
                van_masses = [cc for i, cc in enumerate(cc_list)
                                 if mass_vect[i]==0]
                if len(van_masses)>0:
                    print(" Vanishing masses: "+str(van_masses))
                masses_SO_even.append(cc_mass_dict)
            if len(elliptic_traces_SO_even)<n/2+1:
                ell_tr_dict = contrib_ell_SO_even(n, wt_bounds,
                        ctx.SO_even[n/2-1], masses_SO_even[n/2-1])
                print(" Computed Tell")
                elliptic_traces_SO_even.append(ell_tr_dict)
            else:
                ell_tr_dict = elliptic_traces_SO_even[n/2]
            if len(EPchar_list_SO_even)<n/2:
                EPchar_list_SO_even.append(
                        {dw: EP_minus_elliptic[dw]+ell_tr_dict[dw]
                         for dw in chain_gen(it_dw_SO_even(n, *wt_bounds),
                                             ctx.SO_even[n/2-1])})
            card_Lpacket = binomial(n, n/2)
            num_new_para = \
                  {dw: (EP_minus_elliptic[dw]+ell_tr_dict[dw] -endo_contrib[dw])
                       / card_Lpacket * (1 if dw[n-1]>0 else 1/2)
                   for dw in chain_gen(it_dw_SO_even(n, *wt_bounds),
                                       ctx.SO_even[n/2-1])}
            if len(new_orth_even_para_list)<n/2:
                new_orth_even_para_list.append(num_new_para)
        # Sp_{2n}
        if n<=max_rk_Sp:
            print("Sp_"+str(2*n)+":")
            EP_minus_elliptic = EPchar_Sp(n, elliptic_traces_Sp,
                    elliptic_traces_SO_odd[1], wt_bounds, ctx.Sp[n-1],
                    minus_elliptic=True)
            print(" Computed EP char minus Tell")
            endo_contrib = parallel_all_endo_contrib_Sp(n, wt_bounds,
                    ctx.Sp_bymask[n-1], new_sympl_para_list,
                    new_orth_odd_para_list, new_orth_even_para_list)
            print(" Computed endoscopic contributions to EP char")
            if len(masses_Sp)<n:
                dw_list = [dw for dw in it_dw_Sp(n, maxw_Sp[n-1], 1, 2)
                                  if Mod(sum(dw),2)==0] \
                        + [dw for dw in other_dw_Sp[n-1] if Mod(sum(dw),2)==0]
                ell_tr_vect = vector(QQ,
                        [(-1)^(n*(n+1)/2)*endo_contrib[dw]-EP_minus_elliptic[dw]
                         for dw in dw_list])
                if n!=8:
                    cc_list, traces_mat = mat_tr_alg_rep('C', n, dw_list,
                                                         cc_Qbar_Sp(n))
                else:
                    # if n==8 we use the computation of "easy" masses via
                    # orbital integrals
                    easy_masses = load_from_txt("easy_masses_Sp16.txt")
                    easy_ell_tr_dict = contrib_ell_Sp(n, wt_bounds, ctx.Sp[n-1],
                            easy_masses) 
                    for i, dw in enumerate(dw_list):
                        ell_tr_vect[i] -= easy_ell_tr_dict[dw]
                    cc_list, traces_mat = mat_tr_alg_rep('C', n, dw_list,
                          [cc for cc in cc_Qbar_Sp(n) if not cc in easy_masses])
                print(" "+str(len(dw_list))+" equations, "+str(len(cc_list))
                      +" unknown")
                if traces_mat.rank()<len(cc_list):
                    raise ValueError("Not enough weights for Sp_"+str(2*n))
                #print(cc_list, '\n', ell_tr_vect, '\n', traces_mat)
                mass_vect = traces_mat.solve_left(ell_tr_vect)
                if mass_vect*traces_mat!=ell_tr_vect:
                    raise ValueError("Solving the linear system failed for Sp_"
                                     +str(2*n))
                else:
                    print(" Solved the linear system and computed masses")
                cc_mass_dict = reconstruct_cc_mass_dict_CD(cc_list, mass_vect)
                van_masses = [cc for i, cc in enumerate(cc_list)
                                 if mass_vect[i]==0]
                if len(van_masses)>0:
                    print(" Vanishing masses: "+str(van_masses))
                if n==8:
                    for cc, m in easy_masses.items():
                        cc_mass_dict[cc] = m
                masses_Sp.append(cc_mass_dict)
            if len(elliptic_traces_Sp)<n+1:
                ell_tr_dict = contrib_ell_Sp(n, wt_bounds, ctx.Sp[n-1],
                                             masses_Sp[n-1]) 
                print(" Computed Tell")
                elliptic_traces_Sp.append(ell_tr_dict)
            else:
                ell_tr_dict = elliptic_traces_Sp[n]
            if len(EPchar_list_Sp)<n:
                EPchar_list_Sp.append(
                        {dw: EP_minus_elliptic[dw]+ell_tr_dict[dw]
                         for dw in chain_gen(it_dw_Sp(n, *wt_bounds),
                                             ctx.Sp[n-1])})
            card_Lpacket = 2^n
            num_new_para = \
                 {dw : ((-1)^(n*(n+1)/2)*(EP_minus_elliptic[dw]+ell_tr_dict[dw])
                        -endo_contrib[dw]) / card_Lpacket
                  for dw in chain_gen(it_dw_Sp(n, *wt_bounds), ctx.Sp[n-1])}
            if len(new_orth_odd_para_list)<n+1:
                new_orth_odd_para_list.append(num_new_para)
