load("verify.sage")
load("util.sage")
load("util_db.sage")

print("Parameters of the form 2 I_w, w odd between 25 and 53.")
db_j2 = {}
fixedR = RealField(70)
with open("../contradict_vect/db_j2", "r") as fp:
    s = fp.readline().rstrip()
    while s:
        wt1_str, mult1, wt2_str, mult2, t1, t2, min_eig = s.split(':')
        wt1_str_as_list = wt1_str.replace(' ', '').replace('[', '')\
                .replace(']', '').split(',')
        wt2_str_as_list = wt2_str.replace(' ', '').replace('[', '')\
                .replace(']', '').split(',')
        wt1 = tuple(ZZ(x) for x in wt1_str_as_list)
        wt2 = tuple(ZZ(x) for x in wt2_str_as_list)
        db_j2[wt1] = (wt1, ZZ(mult1), wt2, ZZ(mult2), fixedR(5),
                      fixedR(min_eig), fixedR(t1), fixedR(t2))
        s = fp.readline().rstrip()

# now we check section 2.4.7
for i in range(13, 28):
    wt = (0, 0, 2*i-1)
    if not wt in db_j2:
        raise ValueError
    val, err = CF_over_Phi0_pair_nodb(*(db_j2[wt]))
    print(val, err)
    if not(val<0) or err>1/10000000000:
        raise ValueError
