load("verify.sage")
load("util.sage")
load("util_db.sage")

print("Motivic weight 22, mult>=2")
db = {}
append_db(db, "../contradict_vect/db_w22_mult2")
verify(db, 22, 4.4, 2, 100000, verbose=True)

print("\nMotivic weight 22, mult 1")
db = {}
append_db(db, "../contradict_vect/db_w22_mult1")
verify(db, 22, 4.4, 1, 100000, verbose=True)

print("\nMotivic weight 23, mult>=2")
db = {}
append_db(db, "../contradict_vect/db_w23_mult2")
verify(db, 23, 9.74, 2, 1000000, verbose=True)

def is_reg(wt):
    if wt[0]>1 or wt[1]>1:
        return False
    for i in range(2, len(wt)-1):
        if wt[i]==wt[i+1]:
            return False
    return True

print("\nMotivic weight 23, mult 1")
db = {}
append_db(db, "../contradict_vect/db_w23_mult1")
L23 = verify(db, 23, 9.74, 1, 1000000, verbose=True)
print("Regular ones:")
print([wt for wt, _ in L23 if is_reg(wt)])

print("\nMotivic weight 23, mult 1, under GRH")
L23_nonreg = [wt for wt, _ in L23 if not is_reg(wt)]
load("func_GRH.sage")
db = {}
append_db(db, "../contradict_vect/db_w23_GRH")
verify_enum(db, 23, L23_nonreg, 1, verbose=True)

load("func_noGRH.sage")

db = {}
append_db(db, "../contradict_vect/db_reg_selfdual")
count = 0
for n in range(6,13):
    for dw in it_dw_Sp(n, 12, 1, 2):
        if Mod(sum(dw),2)==1 or dw[0]+n!=12:
            continue
        count += 1
        if not dw2wt_Sp(dw) in db:
            print(str(dw2wt_Sp(dw))+" not in db")
            raise ValueError
for n in [8, 10, 12]:
    for dw in it_dw_SO_even(n, 12, 1, 2):
        if Mod(sum(dw),2)==1 or dw[0]+n-1!=12:
            continue
        count += 1
        if not dw2wt_SO_even(dw) in db:
            print(str(dw2wt_SO_even(dw))+" not in db")
            raise ValueError
print(str(count)+" relevant parameters in dim 13-25, motivic wt 24")
L24 = []
for d in range(13, 26):
    if Mod(d, 4)==2:
        continue
    L24.append(verify_reg_selfdual(db, 24, d, verbose=True, ret_bad=True))
# L24 now contains a list of lists of possible Langlands parameters of level one
# algebraic regular pi's in motivic weight 24 and dimension >12 (automatically
# <=25)
